Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.user
Interface UserProvider

All Known Implementing Classes:
  ClearspaceUserProvider, DefaultUserProvider, HybridUserProvider, JDBCUserProvider, LdapUserProvider, NativeUserProvider, POP3UserProvider

    public interface UserProvider

Provider interface for the user system.

Author:
  Matt Tucker

Method Summary
`User` | `createUser(String username, String password, String name, String email)` Creates a new user.
`void` | `deleteUser(String username)` Delets a user.
`Collection<User>` | `findUsers(Set<String> fields, String query)` Searches for users based on a set of fields and a query string.
`Collection<User>` | `findUsers(Set<String> fields, String query, int startIndex, int numResults)` Searches for users based on a set of fields and a query string.
`Set<String>` | `getSearchFields()` Returns the set of fields that can be used for searching for users.
`int` | `getUserCount()` Returns the number of users in the system.
`Collection<String>` | `getUsernames()` Returns an unmodifiable Collection of usernames of all users in the system.
`Collection<User>` | `getUsers()` Returns an unmodifiable Collections of all users in the system.
`Collection<User>` | `getUsers(int startIndex, int numResults)` Returns an unmodifiable Collections of users in the system within the specified range.
`boolean` | `isEmailRequired()` Returns true if this UserProvider requires an email address to be set on User objects.
`boolean` | `isNameRequired()` Returns true if this UserProvider requires a name to be set on User objects.
`boolean` | `isReadOnly()` Returns true if this UserProvider is read-only.
`User` | `loadUser(String username)` Loads the specified user by username.
`void` | `setCreationDate(String username, Date creationDate)` Sets the date the user was created.
`void` | `setEmail(String username, String email)` Sets the user's email address.
`void` | `setModificationDate(String username, Date modificationDate)` Sets the date the user was last modified.
`void` | `setName(String username, String name)` Sets the user's name.

Method Detail

### loadUser

    User loadUser(String username)
                  throws UserNotFoundException

  Loads the specified user by username.

  Parameters:
    `username` - the username
  Returns:
    the User.
  Throws:
    `UserNotFoundException` - if the User could not be loaded.

### createUser

    User createUser(String username,
                    String password,
                    String name,
                    String email)
                    throws UserAlreadyExistsException

  Creates a new user. This method should throw an UnsupportedOperationException if this operation is not supporte by the backend user store.

  Parameters:
    `username` - the username.
    `password` - the plain-text password.
    `name` - the user's name, which can be `null`, unless isNameRequired is set to true.
    `email` - the user's email address, which can be `null`, unless isEmailRequired is set to true.
  Returns:
    a new User.
  Throws:
    `UserAlreadyExistsException` - if the username is already in use.

### deleteUser

    void deleteUser(String username)

  Delets a user. This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `username` - the username to delete.

### getUserCount

    int getUserCount()

  Returns the number of users in the system.

  Returns:
    the total number of users.

### getUsers

    Collection<User> getUsers()

  Returns an unmodifiable Collections of all users in the system. The `UserCollection` class can be used to assist in the implementation of this method. It takes a String [] of usernames and presents it as a Collection of User objects (obtained with calls to `UserManager.getUser(String)`.

  Returns:
    an unmodifiable Collection of all users.

### getUsernames

    Collection<String> getUsernames()

  Returns an unmodifiable Collection of usernames of all users in the system.

  Returns:
    an unmodifiable Collection of all usernames in the system.

### getUsers

    Collection<User> getUsers(int startIndex,
                              int numResults)

  Returns an unmodifiable Collections of users in the system within the specified range. The `UserCollection` class can be used to assist in the implementation of this method. It takes a String [] of usernames and presents it as a Collection of User objects (obtained with calls to `UserManager.getUser(String)`.

  It is possible that the number of results returned will be less than that specified by `numResults` if `numResults` is greater than the number of records left to display.

  Parameters:
    `startIndex` - the beginning index to start the results at.
    `numResults` - the total number of results to return.
  Returns:
    an unmodifiable Collection of users within the specified range.

### setName

    void setName(String username,
                 String name)
                 throws UserNotFoundException

  Sets the user's name. This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `username` - the username.
    `name` - the name.
  Throws:
    `UserNotFoundException` - if the user could not be found.

### setEmail

    void setEmail(String username,
                  String email)
                  throws UserNotFoundException

  Sets the user's email address. This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `username` - the username.
    `email` - the email address.
  Throws:
    `UserNotFoundException` - if the user could not be found.

### setCreationDate

    void setCreationDate(String username,
                         Date creationDate)
                         throws UserNotFoundException

  Sets the date the user was created. This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `username` - the username.
    `creationDate` - the date the user was created.
  Throws:
    `UserNotFoundException` - if the user could not be found.

### setModificationDate

    void setModificationDate(String username,
                             Date modificationDate)
                             throws UserNotFoundException

  Sets the date the user was last modified. This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `username` - the username.
    `modificationDate` - the date the user was last modified.
  Throws:
    `UserNotFoundException` - if the user could not be found.

### getSearchFields

    Set<String> getSearchFields()
                                throws UnsupportedOperationException

  Returns the set of fields that can be used for searching for users. Each field returned must support wild-card and keyword searching. For example, an implementation might send back the set {"Username", "Name", "Email"}. Any of those three fields can then be used in a search with the `findUsers(Set,String)` method.

  This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Returns:
    the valid search fields.
  Throws:
    `UnsupportedOperationException` - if the provider does not support the operation (this is an optional operation).

### findUsers

    Collection<User> findUsers(Set<String> fields,
                               String query)
                               throws UnsupportedOperationException

  Searches for users based on a set of fields and a query string. The fields must be taken from the values returned by `getSearchFields()`. The query can include wildcards. For example, a search on the field "Name" with a query of "Ma*" might return user's with the name "Matt", "Martha" and "Madeline".

  This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `fields` - the fields to search on.
    `query` - the query string.
  Returns:
    a Collection of users that match the search.
  Throws:
    `UnsupportedOperationException` - if the provider does not support the operation (this is an optional operation).

### findUsers

    Collection<User> findUsers(Set<String> fields,
                               String query,
                               int startIndex,
                               int numResults)
                               throws UnsupportedOperationException

  Searches for users based on a set of fields and a query string. The fields must be taken from the values returned by `getSearchFields()`. The query can include wildcards. For example, a search on the field "Name" with a query of "Ma*" might return user's with the name "Matt", "Martha" and "Madeline".

  The startIndex and numResults parameters are used to page through search results. For example, if the startIndex is 0 and numResults is 10, the first 10 search results will be returned. Note that numResults is a request for the number of results to return and that the actual number of results returned may be fewer.

  This method should throw an UnsupportedOperationException if this operation is not supported by the backend user store.

  Parameters:
    `fields` - the fields to search on.
    `query` - the query string.
    `startIndex` - the starting index in the search result to return.
    `numResults` - the number of users to return in the search result.
  Returns:
    a Collection of users that match the search.
  Throws:
    `UnsupportedOperationException` - if the provider does not support the operation (this is an optional operation).

### isReadOnly

    boolean isReadOnly()

  Returns true if this UserProvider is read-only. When read-only, users can not be created, deleted, or modified.

  Returns:
    true if the user provider is read-only.

### isNameRequired

    boolean isNameRequired()

  Returns true if this UserProvider requires a name to be set on User objects.

  Returns:
    true if an name is required with this provider.

### isEmailRequired

    boolean isEmailRequired()

  Returns true if this UserProvider requires an email address to be set on User objects.

  Returns:
    true if an email address is required with this provider.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.